local mod = ...



-- Starting Tile and Plantable list
mod:overrideAsset({
    Id = "DEFAULT_BALANCING",
    StartingTileResourceRequirement = {
        {
            Resource = "BERRIES",
            Quantity = 1
        },
        {
            Resource = "STONE",
            Quantity = 1
        },
        {
            Resource = "WOOD",
            Quantity = 40
        },
    },
    -- PlantableList = {
    --     "PLANTABLE_DESERT_TREE_DATE",
    --     "PLANTABLE_DESERT_TREE_CANE",
    --     "PLANTABLE_DESERT_TREE_PALM1",
    --     "PLANTABLE_DESERT_TREE_PALM2",
    -- }
})

mod:overrideAsset({
    Id = "BUILDING_FUNCTION_FORESTER",
    PlantableAssetList = {
        "PLANTABLE_DESERT_TREE_DATE",
        "PLANTABLE_DESERT_TREE_CANE",
        "PLANTABLE_DESERT_TREE_PALM1",
        "PLANTABLE_DESERT_TREE_PALM2",
    },
})



-- Change Berries to Dates ---------------------------------------------------------------
mod:overrideAsset({
    Id = "BERRIES",
    ResourceName = "RESOURCE_NAME_DATE",
    VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 }
})



-- Remove extraction zone requirement for Foragers ---------------------------------------------------------------
mod:overrideAsset({
    Id = "GATHERER",
    RelatedZone = ""
})



-- Assets
mod:registerAssetId("models/Desert1.fbx/Prefab/TreeDate", "PREFAB_DESERT_TREE_DATE")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreePalm1", "PREFAB_DESERT_TREE_PALM1")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreePalm2", "PREFAB_DESERT_TREE_PALM2")
mod:registerAssetId("models/Desert1.fbx/Prefab/TreeCane", "PREFAB_DESERT_TREE_CANE")
mod:registerAssetId("models/Desert1.fbx/Prefab/Desert", "PREFAB_DESERT_DESERT")



-- Transparency -------------------------------------------------------------------------------------
mod:registerAssetId("models/Desert1.fbx/Materials/Material.Desert", "MATERIAL_DESERT_TRANSPARENT")
mod:overrideAsset({
    Id = "MATERIAL_DESERT_TRANSPARENT",
    HasAlphaTest = true
})



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeDate", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeDate", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_DESERT_TREE_DATE", { DataType = "COMP_GROUNDED", AutoDisable = true })
mod:registerAssetId("icons/Date.png", "ICON_ANTIGUA_DATE", "ATLAS_CELL")

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_DATE",
    Name = "PLANTABLE_DESERT_TREE_DATE_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_DATE",
    Icon = "ICON_ANTIGUA_DATE",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm1", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm1", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_DESERT_TREE_PALM1", { DataType = "COMP_GROUNDED", AutoDisable = true })
mod:registerAssetId("icons/Palm1.png", "ICON_ANTIGUA_PALM1", "ATLAS_CELL")

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM1",
    Name = "PLANTABLE_DESERT_TREE_PALM1_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM1",
    Icon = "ICON_ANTIGUA_PALM1",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm2", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreePalm2", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_DESERT_TREE_PALM2", { DataType = "COMP_GROUNDED", AutoDisable = true })
mod:registerAssetId("icons/Palm2.png", "ICON_ANTIGUA_PALM2", "ATLAS_CELL")

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_PALM2",
    Name = "PLANTABLE_DESERT_TREE_PALM2_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_PALM2",
    Icon = "ICON_ANTIGUA_PALM2",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeCane", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 14.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/TreeCane", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_DESERT_TREE_CANE", { DataType = "COMP_GROUNDED", AutoDisable = true })
mod:registerAssetId("icons/Cane.png", "ICON_ANTIGUA_CANE", "ATLAS_CELL")

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_TREE_CANE",
    Name = "PLANTABLE_DESERT_TREE_CANE_NAME",
    PlantPrefab = "PREFAB_DESERT_TREE_CANE",
    Icon = "ICON_ANTIGUA_CANE",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})


mod:registerPrefabComponent("models/Desert1.fbx/Prefab/Desert", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 8.0 })
mod:registerPrefabComponent("models/Desert1.fbx/Prefab/Desert", { DataType = "COMP_TREE" })
mod:registerPrefabComponent("PREFAB_DESERT_DESERT", { DataType = "COMP_GROUNDED", AutoDisable = true })
mod:registerAssetId("icons/Desert.png", "ICON_ANTIGUA_DESERT", "ATLAS_CELL")

mod:registerAsset({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_DESERT_DESERT",
    Name = "PLANTABLE_DESERT_DESERT_NAME",
    PlantPrefab = "PREFAB_DESERT_DESERT",
    Icon = "ICON_ANTIGUA_DESERT",
    MinimumScale = 2, -- min size at full growth
    MaximumScale = 2 -- max size at full growth
})



-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreeDate", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",
    IsReplenishable = true,
    ReplenishDurationInDays = 14,
    ReplenishQuantity = 2,
    ResourceValue = 2.0, -- how many are gathered with each pick
    AvailableQuantity = 2, -- maximum container stock
    Radius = 0.85, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreePalm1", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreePalm2", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/TreeCane", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "WOOD",
    IsReplenishable = false,
    ResourceValue = 0.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})


mod:registerPrefabComponent( "models/Desert1.fbx/Prefab/Desert", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "GOLD_COINS",
    IsReplenishable = false,
    ResourceValue = 0.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 1.3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})



-- registering map files
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/tree_density_map.png", "PALM_DENSITY_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mod:registerAssetId("maps/desert_density.png", "DESERT_DENSITY_MAP")



-- register custom map
mod:registerAsset({
	DataType = "CUSTOM_MAP",
	Id = "MAP_ANTIGUA",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -10,
	MaxHeight = 60,
	VillagePathList = {
		{
			Entrance = { 351, 0, 827 },
			Exit = { 388, 0, 213 },
		},
		{
			Entrance = { 414, 0, 827 },
			Exit = { 196, 0, 275 },
		},
		{
			Entrance = { 262, 0, 599 },
			Exit = { 587, 0, 171 },
		},
		{
			Entrance = { 448, 0, 215 },
			Exit = { 715, 0, 308 },
		},
		{
			Entrance = { 501, 0, 749 },
			Exit = { 773, 0, 441 },
		},
		{
			Entrance = { 682, 0, 538 },
			Exit = { 659, 0, 253 },
		},
		{
			Entrance = { 329, 0, 653 },
			Exit = { 653, 0, 611 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 303 , 30 , 373 },
			Orientation = { 0.0, -55.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 248 , 21 , 348 },
			Orientation = { 0.0, -80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 287 , 19 , 286 },
			Orientation = { 0.0, -170.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 413 , 30 , 335 },
			Orientation = { 0.0, 60.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 455 , 18 , 783 },
			Orientation = { 0.0, 25.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 540 , 26 , 308 },
			Orientation = { 0.0, -100.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 721 , 24 , 352 },
			Orientation = { 0.0, 25.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 818 , 14 , 788 },
			Orientation = { 0.0, -90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 353 , 17 , 298 },
			Orientation = { 0.0, 170.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
		{
			-- Palm trees
			DensityMap = "PALM_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_DESERT_TREE_PALM1" },
                    RandomWeight = 0.6,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.0
                    },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 0.8, 0.8, 0.8, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
				},
				{
                    PrefabList = { "PREFAB_DESERT_TREE_PALM2" },
                    RandomWeight = 0.3,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.0
                    },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 0.8, 0.8, 0.8, 1 },
                        Max = { 1, 1, 1, 1 }
                    }
                },
                {
                    PrefabList = { "PREFAB_DESERT_TREE_DATE" },
                    RandomWeight = 0.1,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.0
                    },
                    OrientationRange = {
                        Min = { 0, -180, 0 },
                        Max = { 0, 180, 0 }
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15
                    },
                    ColorRange = {
                        Min = { 0.8, 0.8, 0.8, 1 },
                        Max = { 1, 1, 1, 1 }
                   }
                },
            }
        },
		{
			-- Desert
			DensityMap = "DESERT_DENSITY_MAP",
			Density =1.0,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_DESERT_DESERT" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 2,
							Max = 2
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
